import { AEMContainerComponent, AEMContainerComponentProperties } from '../aem-container/aem-container.component';
import * as i0 from "@angular/core";
/**
 * @private
 */
export declare const ALLOWED_PLACEHOLDER_CLASS_NAMES = "aem-AllowedComponent--list";
/**
 * @private
 */
export declare const ALLOWED_COMPONENT_TITLE_CLASS_NAMES = "aem-AllowedComponent--title";
/**
 * @private
 */
export declare const ALLOWED_COMPONENT_PLACEHOLDER_CLASS_NAMES = "aem-AllowedComponent--component cq-placeholder placeholder";
/**
 * Component that is allowed to be used on the page by the editor
 */
export interface AllowedComponent {
    /**
     * Path to the component under apps
     */
    path: string;
    /**
     * Title of the component
     */
    title: string;
}
/**
 * AllowedComponents collection
 */
export interface AllowedComponents {
    applicable: boolean;
    /**
     * List of allowed components
     */
    components: AllowedComponent[];
}
/**
 * Properties for the allowed components container
 */
export interface AEMAllowedComponentsContainerComponentProperties extends AEMContainerComponentProperties {
    /**
     * List of allowed components for the container
     */
    allowedComponents: AllowedComponents;
    /**
     *  Label to display when there are no allowed components
     */
    _allowedComponentPlaceholderListEmptyLabel?: string;
    /**
     * Title of the placeholder list
     */
    title: string;
}
export declare class AEMAllowedComponentsContainerComponent extends AEMContainerComponent implements AEMAllowedComponentsContainerComponentProperties {
    title: string;
    emptyLabel: string;
    allowedComponents: {
        applicable: boolean;
        components: any;
    };
    isAllowedComponentsApplicable(): boolean;
    getAllowedComponentListPlaceholderClassNames(): string;
    getAllowedComponentListLabel(): string;
    getAllowedComponents(): AllowedComponent[];
    get allowedComponentListTitleClassNames(): string;
    get allowedComponentClassNames(): string;
    static ɵfac: i0.ɵɵFactoryDeclaration<AEMAllowedComponentsContainerComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<AEMAllowedComponentsContainerComponent, "aem-allowed-components-container", never, { "title": "title"; "emptyLabel": "emptyLabel"; "allowedComponents": "allowedComponents"; }, {}, never, never>;
}
