import { AfterViewInit, ChangeDetectorRef, Compiler, ComponentFactoryResolver, Injector, OnChanges, OnDestroy, OnInit, Renderer2, ViewContainerRef } from '@angular/core';
import * as i0 from "@angular/core";
export declare class AEMComponentDirective implements AfterViewInit, OnInit, OnDestroy, OnChanges {
    private renderer;
    private viewContainer;
    private compiler;
    private injector;
    private factoryResolver;
    private _changeDetectorRef;
    /**
     * Dynamically created component
     */
    private _component;
    /**
     * Model item that corresponds to the current component
     */
    private _cqItem;
    get cqItem(): any;
    set cqItem(value: any);
    get changeDetectorRef(): ChangeDetectorRef;
    /**
     * Path to the model structure associated with the current component
     */
    cqPath: string;
    /**
     * Name of the current instance of the component
     */
    itemName: string;
    /**
     * HtmlElement attributes for the current instance of the component
     */
    itemAttrs: any;
    loaded: boolean;
    aemComponent: any;
    constructor(renderer: Renderer2, viewContainer: ViewContainerRef, compiler: Compiler, injector: Injector, factoryResolver: ComponentFactoryResolver, _changeDetectorRef: ChangeDetectorRef);
    ngOnInit(): Promise<void>;
    initializeAsync(): Promise<void>;
    ngOnChanges(): void;
    /**
     * Returns the type of the cqItem if exists.
     */
    get type(): string | undefined;
    /**
     * Renders a component dynamically based on the component definition
     *
     * @param componentDefinition The component definition to render
     */
    private renderComponent;
    private renderWithFactory;
    /**
     * Updates the data of the component based the data of the directive
     */
    private updateComponentData;
    /**
     * Adds the applied css class names in to the element
     */
    private includeAppliedCSSClasses;
    /**
     * Adds the specified item attributes to the element
     */
    private setupItemAttrs;
    /**
     * Determines if the placeholder should e displayed.
     *
     * @param editConfig - the edit config of the directive
     */
    private usePlaceholder;
    /**
     * Setups the placeholder of needed for the AEM editor
     *
     * @param editConfig - the editConfig, which will dictate the classes to be added on.
     */
    private setupPlaceholder;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<AEMComponentDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<AEMComponentDirective, "[aemComponent]", never, { "cqItem": "cqItem"; "cqPath": "cqPath"; "itemName": "itemName"; "itemAttrs": "itemAttrs"; "loaded": "loaded"; "aemComponent": "aemComponent"; }, {}, never>;
}
