import { AEMAllowedComponentsContainerComponent, AEMAllowedComponentsContainerComponentProperties } from '../aem-allowed-components-container/aem-allowed-components-container.component';
import * as i0 from "@angular/core";
/**
 * Properties corresponding to the AEMResponsiveGridComponent.
 * The AEMResponsiveGridComponent carries the base presentational logic of the AEM Layout Container.
 */
export interface AEMResponsiveGridComponentProperties extends AEMAllowedComponentsContainerComponentProperties {
    /**
     * Class names associated with the current responsive grid
     */
    gridClassNames: string;
    /**
     * Map of class names corresponding to each child of the current responsive grid
     */
    columnClassNames: {
        [key: string]: string;
    };
    /**
     * Current number of columns of the grid
     */
    columnCount: number;
}
export declare class AEMResponsiveGridComponent extends AEMAllowedComponentsContainerComponent implements AEMResponsiveGridComponentProperties {
    gridClassNames: any;
    columnClassNames: any;
    classNames: any;
    columnCount: any;
    /**
     * Returns the column class names for a given column
     * @param itemKey - The key of the column item
     */
    getColumnClassNames(itemKey: string): string;
    /**
     * Returns the placeholder classes
     */
    getPlaceholderClassNames(): string;
    /**
     * Returns the class names of the responsive grid based on the data from the cqModel
     */
    getHostClassNames(): string;
    /**
     * Returns the aggregated path of this container path and the provided path
     *
     * @param path - the provided path to aggregate with the container path
     */
    getAttrDataPath(path: string): string | null;
    static ɵfac: i0.ɵɵFactoryDeclaration<AEMResponsiveGridComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<AEMResponsiveGridComponent, "aem-responsivegrid", never, { "gridClassNames": "gridClassNames"; "columnClassNames": "columnClassNames"; "classNames": "classNames"; "columnCount": "columnCount"; }, {}, never, never>;
}
