import { ActivatedRouteSnapshot, RouteReuseStrategy, DetachedRouteHandle } from '@angular/router';
/**
 * Implements RouteReuseStrategy to customize route reuse.
 */
export declare class AemPageRouteReuseStrategy implements RouteReuseStrategy {
    /** Determines if this route (and its subtree) should be detached to be reused later. */
    shouldDetach(route: ActivatedRouteSnapshot): boolean;
    /** Not storing deteached route. */
    store(route: ActivatedRouteSnapshot, detachedTree: DetachedRouteHandle): void;
    /** Determines if this route (and its subtree) should be reattached. */
    shouldAttach(route: ActivatedRouteSnapshot): boolean;
    /** Retrieves the previously stored route. */
    retrieve(route: ActivatedRouteSnapshot): DetachedRouteHandle | null;
    /** Determines if a route should be reused */
    shouldReuseRoute(future: ActivatedRouteSnapshot, curr: ActivatedRouteSnapshot): boolean;
}
